(in-package :netfarm-interactor)

(clim:define-presentation-type history-object ()
  :inherit-from t)
(clim:define-presentation-to-command-translator inspect-clicked-object
    (netfarm:object com-inspect-object netfarm-interactor-app
     :gesture :select)
    (object)
  (list object))
(clim:define-presentation-to-command-translator inspect-history-object
    (history-object com-inspect-object netfarm-interactor-app
     :gesture :select)
    (object)
  (list object))

(clim:define-presentation-method clim:present
    (object (type netfarm:object) stream (view graphical-view) &key)
  (clim:with-text-family (stream :fix)
    (write-string (netfarm:hash-object* object) stream)))

(defvar *combinations* (make-hash-table :test 'equal))
(defvar *escaping* nil)
(defmacro define-combination ((name stream &rest arguments) &body body)
  (alexandria:with-gensyms ((arguments* arguments))
    `(setf (gethash ,(string-downcase name) *combinations*)
           (lambda (,stream ,arguments*)
             (destructuring-bind ,arguments ,arguments*
               ,@body)))))

(define-combination (vertically stream &rest parts)
  (dolist (part parts)
    (write-presentation part stream)
    (fresh-line stream)))
(define-combination (horizontally stream &rest parts)
  (clim:formatting-item-list (stream)
    (dolist (part parts)
      (clim:formatting-cell (stream)
        (write-presentation part stream)))))
(define-combination (sequentially stream &rest parts)
  (dolist (part parts)
    (write-presentation part stream)))
(define-combination (tabling stream &rest rows)
  (clim:formatting-table (stream)
    (let ((first? t))
      (dolist (row rows)
        (clim:formatting-row (stream)
          (if first?
              (clim:with-text-face (stream :bold)
                (dolist (cell row)
                  (clim:formatting-cell (stream)
                    (write-presentation cell stream))))
              (dolist (cell row)
                (clim:formatting-cell (stream)
                  (write-presentation cell stream))))
          (setf first? nil))))))
(define-combination (escaping stream thing)
  (clim:with-text-style (stream (clim:make-text-style :fix :bold 10))
    (let ((*escaping* t))
      (write-presentation thing stream))))
(define-combination (text stream thing)
  (let ((*escaping* t))
    (typecase thing
      (string (write-string thing stream))
      (t (clim:with-text-family (stream :fix)
           (format stream "[~s is not a string]" thing))))))

(define-combination (header stream text)
  (clim:with-text-style (stream (clim:make-text-style :serif :bold 24))
    (write-presentation text stream)))
(define-combination (code stream text)
  (clim:with-text-style (stream (clim:make-text-style :fix :bold 10))
    (write-presentation text stream)))

(defgeneric write-presentation (presentation stream)
  (:method ((combination list) stream)
    (if *escaping*
	(progn
	  (write-char #\( stream)
	  (loop for (value . more?) on combination
		do (write-presentation value stream)
		when more? do (write-char #\Space stream))
	  (write-char #\) stream))
	(let ((function (gethash (first combination) *combinations*)))
	  (cond
            ((null function)
	     (clim:with-text-family (stream :fix)
	       (format stream "[No combination named ~a]" (first combination)))
             (dolist (part (rest combination))
               (fresh-line stream)
               (write-presentation part stream)))
            (t
	     (funcall function stream (rest combination)))))))
  (:method ((string string) stream)
    (if *escaping*
        (prin1 string stream)
        (write-string string stream)))
  (:method ((number number) stream)
    (princ number stream))
  (:method ((object netfarm:object) stream)
    (clim:present object 'netfarm:object :stream stream))
  (:method ((true (eql :true)) stream)
    (clim:with-text-face (stream :italic)
      (write-string "true" stream)))
  (:method ((false (eql :false)) stream)
    (clim:with-text-face (stream :italic)
      (write-string "false" stream)))
  (:method (thing stream)
    (clim:with-text-style (stream (clim:make-text-style :fix :bold 10))
      (prin1 thing stream))))

(defun display-presentation (frame pane)
  (setf (clim:stream-end-of-line-action pane)
        #+mcclim :wrap* #-mcclim :wrap)
  (write-presentation (netfarm-presentation frame)
                      pane))

(clim:define-presentation-translator history->object
    (history-object netfarm:object netfarm-interactor-app
     :gesture :select)
    (object)
  object)
(defun display-history (frame pane)
  (clim:formatting-table (pane)
    (dolist (item (history frame))
      (clim:formatting-row (pane)
        (clim:formatting-cell (pane)
          (clim:present item 'history-object :stream pane))))))
